<template>
  <!--  <el-dialog title="收货地址" :visible.sync="dialogFormVisible">-->
  <el-container>
    <el-header style="width: 100%; height: 80px;font-size: 12px">

      <el-form :inline="true"  label-width="60px"  label-position="left">
        <el-row>

          <el-col :span="22">
            <el-col :span="5" >
              <el-form-item label="状态:">
                <el-select v-model="queryParam.zt" placeholder="状态"  @change="ztChange">
                  <el-option
                    v-for="item in statusOptions"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                  >
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-form-item label="船号:">
              <vxe-pulldown ref="xDown4" transfer >
                <template #default>
                  <vxe-input
                    v-model="queryParam.dcch"
                    placeholder="船号"
                    style="height: 28px;
                    line-height: 28px; width: 140px;"
                    suffix-icon="vxe-icon--search"
                    @keyup="keyupEvent4"
                    @focus="focusEvent4"
                  />
                </template>
                <template #dropdown>
                  <div class="my-dropdown  mytable " style="width: 250px">
                    <vxe-grid
                      highlight-hover-row
                      height="auto"

                      :data="projectData"
                      :columns="projectColumns"
                      @cell-click="cellClickEvent"
                      show-overflow
                    >
                      <template #wgbsEdit="{ row}">
                        <vxe-checkbox v-model="row.wgbs"  checked-value="Y" unchecked-value="N"   disabled ></vxe-checkbox>
                      </template>
                    </vxe-grid>
                  </div>
                </template>
              </vxe-pulldown>


            </el-form-item>
            <!--            <el-form-item label="批量:">-->
            <!--              <el-input v-model="queryParam.pl" type="search" placeholder="批量" ></el-input>-->
            <!--            </el-form-item>-->
            <!--            <el-form-item label="分段:">-->
            <!--              <el-input v-model="queryParam.fd" type="search" placeholder="分段" ></el-input>-->
            <!--            </el-form-item>-->




          </el-col>
          <el-col :span="2">
            <el-form-item style="float: right" >
              <el-button type="success" @click="initList">查询</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>

          <el-col :span="20"  >






            <span style="width:6%" >作业区:</span>
            <el-select v-model="inParam.scdw" placeholder="作业区" clearable style="width: 15%" @change="bzClick" :disabled="flag">
              <el-option
                v-for="item in this.dictData.resourcesCodes"
                :key="item.zyq"
                :label="item.zyq"
                :value="item.zyq"
              >
              </el-option>
            </el-select>

            <span style="width:6%" >班组:</span>
            <el-select v-model="inParam.zyq" placeholder="班组" clearable style="width: 15%" @change="bzClick1">
              <el-option
                v-for="item in this.dictData.zyqs"
                :key="item.zyq+item.resourcesCode"
                :label="item.zyq+item.resourcesCode"
                :value="item.resourcesCode"
              >
              </el-option>
            </el-select>




            <el-select v-model="inParam.scry" placeholder="人员" clearable style="width: 15%" filterable >
              <el-option
                v-for="item in this.dictData.zyrys"
                :key="item.id"
                :label="item.zyq+item.resourcesCode+item.userName"
                :value="item.userName"
              >
              </el-option>
            </el-select>

            <el-button type="info" @click="updates2()" style="width: 5%">批量</el-button>
            <!--            <span style="width:6%" >反馈人员:</span>-->
            <!--            <el-input v-model="inParam.slry" placeholder="反馈人员" clearable style="width:10%"  />-->
            <!--            <span style="width:6%" >反馈日期:</span>-->
            <!--            <el-date-picker v-model="inParam.sljs" value-format="yyyy/MM/dd"     format="yyyy/MM/dd" type="date" style="width: 15%" placeholder="反馈日期"/>-->
            <!--            <el-button type="info" @click="updates('2')" style="width: 5%">批量</el-button>-->
          </el-col>
          <el-col :span="4" >
            <el-form-item style="float: right" >
              <el-button type="success" @click="comLph">确认炉批号</el-button>
              <el-button type="success" @click="slpgclick">派工</el-button>
              <el-button type="success" @click="saveclick">报工</el-button>

            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-header>
    <el-container  style="padding-top: 0px">
      <el-container>
        <el-main>
          <div class="mytable">
            <vxe-grid
              id="id"
              ref="xGrid"
              border
              resizable
              keep-source
              :align="'center'"
              :height="height"
              :auto-resize="true"
              :columns="tableColumn"
              highlight-current-row
              :data="list"
              :scroll-y="{enabled: true}"
              :edit-config="{trigger: 'click', mode: 'cell', showStatus: true}"
              highlight-hover-row
              show-overflow
              show-header-overflow
              :header-cell-style="headerCellStyle"
              :row-style="tableRowClassName"
            >


            </vxe-grid>
          </div>


        </el-main>
      </el-container>
    </el-container>
  </el-container>
</template>

<script>
import {
  getPwPgd,
  savePwFk,
  getPgdBase,
  savePwPgdXd,
  savePwPgdXdBack,
  savePwjhPg,
  savePwjhPgBack, qrlph
} from '@/api/jhzxgl/pgd'
import { mapGetters } from 'vuex'
import XEUtils from 'xe-utils'
import {null2str} from "@/utils/rpkj";
import { getToken } from '@/utils/auth'
import { startLoading, endLoading } from '@/utils'
import { Message } from 'element-ui'
export default {
  name:'PwjhD',
  data() {
    return {
      flag:false,
      queryParam: {
        dcch:'',
        field:'',
        user:'',
        jhrqField:'',
        zt:'42',
        ztHx:'52',
        zyq1:'',
      },
      zyqs:[],
      zyrys:[],
      statusOptions: [
        {
          value: "11",
          label: "已打印",
        },
        {
          value: "42",
          label: "未派工",
        },
        {
          value: "61",
          label: "未报工",
        },
        {
          value: "62",
          label: "已报工",
        },

      ],
      inParam:{
        slry:'',
        slks:'',
        sljs:'',
        dw:'',
        scry:'',
        scdw:''
      },
      list: [],
      heads: { token: getToken() },
      uploadAction: process.env.VUE_APP_BASE_API + '/dmCzplpNew/uploadPl',
      dictData:{},
      height: '500px',
      projectData:[],
      projectData1:[],
      projectColumns: [
        {field: 'cbbm', title: '船号',width: 110},
        { field: 'wgbs', title: '完工标识', width: 80,
          slots:{
            default: 'wgbsEdit'
          },
        },
      ],

      tableColumn: [
        { type: 'checkbox', width: 40 },
        { type: 'seq', width: 40, title: '序号' },
        {
          field: 'djh',
          title: '单据号',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        { field: 'dcCh', title: '船号',width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},

        { field: 'dcPl', title: '批量',width: 80,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'dcFd', title: '分段号',width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'zl', title: '组立',width: 80,formatter: ['dictFormat','ZLLB'],
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'kw', title: '跨位',width: 80,formatter: ['dictFormat','QGKW'],
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'tzbh', title: '套料图号',width: 90,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'jssj', title: '前方需求时间',width: 110,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        { field: 'qgjhrq', title: '切割计划日期',width: 110,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},
        // { field: 'lqlb', title: '领取类型',width: 90,formatter: ['dictFormat','CLlQ'],
        //   filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
        //   filterRender: { name: 'FilterCombination', }},
        // { field: 'lx', title: '物资类型',width: 90,formatter:this.formatterLx,
        //   filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
        //   filterRender: { name: 'FilterCombination', }},

        { field: 'wpgg', title: '规格',width: 80,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', }},


        { field: 'wpxh', title: '材质',width: 80,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],},

      {
          field: 'lldw',
          title: '理料垛位',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'llcs',
          title: '理料层数',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgry',
          title: '切割人员',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgpgry',
          title: '切割派工人',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgpgrq',
          title: '切割派工日期',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgfkry',
          title: '切割反馈人',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgfkrq',
          title: '切割反馈日期',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'qgbz',
          title: '切割备注',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'lphqrry',
          title: '炉批号确认人',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'lphqrrq',
          title: '炉批号确认日期',
          width: 100,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },

      ]
    }
  },
  computed: {
    ...mapGetters(['name', 'bmbm'])
  },
  created() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.initBase()




  },
  methods: {
    tableRowClassName({ row, rowIndex }){
      if (row.lphqrrq){
        return {backgroundColor:'rgb(236, 104, 104)'}
      }
    },
    comLph(){
      const data=this.$refs.xGrid.getCheckboxRecords()
      if(data.length===0){
        this.$message.warning('请选择已确认的数据')
        return
      }
      qrlph(data.filter(item=>!item.lphqrrq)).then(()=>{
        this.$message.success('成功')
        this.initList();
      })

    },
    headerCellStyle ({ column, columnIndex }) {
      if (['qgry','qgpgrq','qgpgry','qgfkry','qgfkrq'].includes(column.property)) {
        return {
          backgroundColor: '#2db7f5',
          color: '#ffffff'
        }
      }
    },
    cellClickEvent({row}) {
      this.queryParam.dcch = row.cbbm
      this.$refs.xDown4.hidePanel()
    },
    focusEvent4() {
      this.$refs.xDown4.showPanel()
    },
    keyupEvent4() {


      if (this.queryParam.dcch) {
        this.projectData = this.projectData1.filter(row => row.cbbm.indexOf(this.queryParam.dcch.toUpperCase()) > -1)
      } else {
        this.projectData = this.projectData1.slice(0)
      }

    },
    ztChange(){
      this.list=[]
    },
    bzClick(){
      console.log(this.dictData.gxry)
      console.log(this.inParam.scdw)
      this.dictData.zyqs= this.zyqs.filter(fst=>fst.zyq===this.inParam.scdw)
      console.log(this.dictData.zyqs)
    },
    bzClick1(){
      console.log(this.dictData.zyrys)
      console.log(this.zyrys)
      this.dictData.zyrys= this.zyrys.filter(fst=>fst.zyq+fst.resourcesCode===this.inParam.scdw+this.inParam.zyq)
      console.log(this.dictData.gxry)
    },
    updates2(){
      let selectRecords = this.$refs.xGrid.getCheckboxRecords()

      if(selectRecords.length>0){
        for(let i = 0; i < selectRecords.length; i++) {

          // selectRecords[i].dw = this.inParam.dw
          //selectRecords[i].scdw = this.inParam.scdw
          selectRecords[i].qgry = this.inParam.scry
          selectRecords[i].qgpgry = this.name
          // selectRecords[i].pwpgrq = this.inParam.scry


        }
        this.$refs.xGrid.updateData(this.list)
      }
    },
    updates(type){


      let selectRecords = this.$refs.xGrid.getCheckboxRecords()

      if(selectRecords.length>0){
        for(let i = 0; i < selectRecords.length; i++) {
          if(type==='1'){

            selectRecords[i].slksrq = this.inParam.slks
          }else if (type==='2'){
            selectRecords[i].fkry = this.inParam.slry
            selectRecords[i].fkrq = this.inParam.sljs
          }

        }
        this.$refs.xGrid.updateData(this.list)
      }

    },

    activeRowMethod({ row, rowIndex }){
      // if(row.zt==="01"){
      //   return  true
      // }else{
      //   return  false
      // }

      return true;
    },

    initBase(){
      getPgdBase({}).then(res=>{
        console.log(res.data)
        this.zyqs=res.data.zyqs
        this.zyrys=res.data.zyrys
        this.dictData = res.data
        this.projectData=res.data.cbbm
        this.projectData1=res.data.cbbm
        if(this.bmbm.slice(-1)==='区'){
          this.inParam.scdw=this.bmbm
          this.flag=true;
          this.bzClick()

        }
      })
    },
    plClick(){
      let selectRecords = this.$refs.xGrid.getCheckboxRecords()
      if(selectRecords.length>0){
        for(let i = 0; i < selectRecords.length; i++) {
          selectRecords[i].fkyy = this.queryParam.fkyy
        }
        this.$refs.xGrid.updateData(this.list)
      }

    },
    saveclick(){
      if(this.queryParam.zt!=='61'){
        return
      }
      let obj=this.$refs.xGrid.getCheckboxRecords()
      // if(obj.length===0){
      //   this.$message({ message: '请填写反馈原因在进行反馈', type: 'warning' })
      //   return
      // }

      savePwjhPgBack({
        'field': 'qgfkrq',
        'fieldry': 'qgfkry',
        'zxZtName':'QGFK',
        'list':obj

      }).then(res=>{
        if(res.success){
          this.initList()
        }
      })
    },

    slpgclick(){
      if(this.queryParam.zt!=="42"){
        return
      }

      let obj=this.$refs.xGrid.getCheckboxRecords()
      if(obj.length===0){
        return
      }
      for(let i =0;i<obj.length;i++){
        let rows =this.$refs.xGrid.getRowSeq(obj[i])
        if(obj[i].qgry==null||obj[i].qgry===''){
          this.$message({ message: '第'+rows+'行施工人不能为空', type: 'error' })
          return
        }

      }
      // 判断施工人 不能为空

      // if(this.queryParam.zt==='02'){
      //   this.$confirm('取消派工？', '提示', {
      //     confirmButtonText: '确定',
      //     cancelButtonText: '取消',
      //     type: 'warning'
      //   }).then(() =>{

      savePwjhPgBack({
        'field': 'qgpgrq',
        'fieldry': 'qgpgry',
        'zxZtName':'QGPG',
        'list':obj

      }).then(res=>{
        if(res.success){
          this.$message({ message: '派工成功', type: 'success' })
          this.initList()
        }
      })

      //   })
      // }else  {
      //   this.$confirm('派工？', '提示', {
      //     confirmButtonText: '确定',
      //     cancelButtonText: '取消',
      //     type: 'warning'
      //   }).then(() =>{
      //     savePwjhPg(obj).then(res=>{
      //       if(res.success){
      //         this.initList()
      //       }
      //     })
      //
      //   })
      // }


    },
    xdClick(){

      if(this.queryParam.zt!=="02"){
        return
      }
      let obj=this.$refs.xGrid.getCheckboxRecords()
      if(obj.length===0){
        return
      }
      if(this.queryParam.zt==='03'){
        this.$confirm('取消接收？', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() =>{
          savePwPgdXdBack(obj).then(res=>{
            if(res.success){
              this.$message({ message: '取消下达成功', type: 'success' })
              this.initList()
            }
          })

        })
      }else  {
        this.$confirm('接收？', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() =>{
          savePwPgdXd(obj).then(res=>{
            if(res.success){
              this.$message({ message: '下达成功', type: 'success' })
              this.initList()
            }
          })

        })
      }


    },
    initList() {
      // if (this.queryParam.dcch === '') {
      //   this.$message.warning('选择船只编号')
      //   return
      // }
      // this.
      if(this.queryParam.zt==='42'){

      }else{
        // this.queryParam.field='pwry';
        this.queryParam.user=this.name;

      }
      this.queryParam.zyq1=this.inParam.scdw
      getPwPgd(this.queryParam).then((res) => {
        this.list = res.data
        if (this.$refs.xGrid) {
          this.$refs.xGrid.loadData(this.list)
          console.log(this.list)
        }

      })
    },
    selectChange(row) {
      // this.$refs.xGrid.clearActived() // 清除单元格激活状态
      this.$refs.xGrid.clearEdit() // 清除单元格激活状态
      //  this.$refs.xGrid.setEditCell(row.row, row.column.property) // 设置单元格为激活状态
      null2str(row.row)
    },
    getHeight() {
      this.height = window.innerHeight - 190
    },

  }
}
</script>
<style lang="scss" scoped >

.el-header{margin:0;padding: 5px;height:auto;
  .el-input{
    width: 140px;
  }
  .el-select{
    width: 140px;
  }

}
.el-container{padding: 0;margin:0;}
.el-main{padding: 0;}
.el-col{padding: 0;height: 32px;}
.el-aside{background: #fff;padding: 0}
.el-container{padding: 0}
.el-row {}
.el-row:last-child {margin-bottom: 0; }

.tableStyles{
  background: #0a76a4;
}

.my-dropdown {
  width: 400px;
  height: 400px;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);
  font-size: 12px;

}
.mytable1{

}
.borderClass{

}
.vxe-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.el-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.keyword-lighten {
  color: #000;
  background-color: #FFFF00;
}

.vxe-textarea--inner {
  line-height: inherit;
}
.el-form-item__label-wrap {
  margin-left: 0px !important;
  float: left;
}
.fontClass{
  font-size: 12px;
  font-weight: bold;
}


</style>
